unit dosHoraDia;

interface
uses
    windows, sysutils, classes,
    dvcrt, dvwin,
    dvHora, dvArq, dosmsg, dvForm, messages;

procedure mostraDataHora;
procedure alteraDataHora;

implementation

{--------------------------------------------------------}
{                 fala o dia e a hora
{--------------------------------------------------------}

procedure mostraDataHora;
var
    hora, minuto, segundo, cent: word;
    diaSemana, dia, mes, ano: word;

    function d2 (n: integer): string;
    begin
         result := intToStr(n);
         if length(result) = 1 then result := '0' + result;
    end;

begin
    getDate (ano, mes, dia, diaSemana);
    dvcrt.gettime (hora, minuto, segundo, cent);

    writeln;
    writeln (tabNomesDias[diaSemana+1], ', ',
             d2(dia), '/', d2(mes), '/', ano, ' - ',
             d2(hora), ':', d2(minuto), ':', d2(segundo));
    writeln;
    writeln;

    falaDiaQualquer (dia, mes, ano);
    falaHoraQualquer (hora, minuto);
end;


procedure ajustaPrivilegios;
const
    SE_SYSTEMTIME_NAME = 'SeSystemtimePrivilege';
var
    hToken: THandle;
    luid: TLargeInteger;
    ReturnLength: DWORD;
    tkp, PrevTokenPriv: TTokenPrivileges;
begin
    if (Win32Platform = VER_PLATFORM_WIN32_NT) then
        begin
            if OpenProcessToken(GetCurrentProcess,
                      TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
                begin
                    try
                        if not LookupPrivilegeValue(nil, SE_SYSTEMTIME_NAME, luid) then Exit;
                        tkp.PrivilegeCount := 1;
                        tkp.Privileges[0].luid := luid;
                        tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
                        if not AdjustTokenPrivileges(hToken, False, tkp, SizeOf(TTOKENPRIVILEGES),
                                                PrevTokenPriv, ReturnLength) then
                                Exit;
                        if (GetLastError <> ERROR_SUCCESS) then
                            begin
                               mensagem ('DV_NOPRV', 1);  // Para mudar a hora  rodar o Dosvox em modo administrador.
                               Exit;
                            end;
                    finally
                          CloseHandle(hToken);
                    end;
                end;
        end;
end;

{--------------------------------------------------------}
{                 altera o relgio
{--------------------------------------------------------}

procedure alteraDataHora;
var
    hora, minuto, segundo, cent: word;
    diaSemana, dia, mes, ano: word;

    hh, mm, d, m, a: integer;
    c: char;

    SystemTime: TSystemTime;

begin
    writeln;
    garanteEspacoTela(10);

    getDate (ano, mes, dia, diaSemana);
    a := ano;
    m := mes;
    d := dia;
    dvcrt.gettime (hora, minuto, segundo, cent);
    hh := hora;
    mm := minuto;

    mensagem ('DV_EDDIA', 1);  {'Editore dia e hora, use as setas, ESC termina'}
    formCria;
    formCampoInt('DV_HORA',  'Hora', hh);
    formCampoInt('DV_MINUT', 'Minuto', mm);
    formCampoInt('DV_DIA',   'Dia', d);
    formCampoInt('DV_MES',   'Ms', m);
    formCampoInt('DV_ANO',   'Ano', a);
    formEdita(true);

    writeln;
    mensagem ('DV_CONFIRMA', 0);   {'Confirma? '}
    c := popupMenuPorLetra('SN');
    if (c = ESC) or (c = 'N') then
        mensagem ('DV_DESIST', 2)       {'Desistiu...'}
    else
        begin
            ajustaPrivilegios;
            fillChar (SystemTime, sizeOf(SystemTime), 0);
            SystemTime.wYear := a;
            SystemTime.wMonth := m;
            SystemTime.wDay := d;
            SystemTime.wHour := hh;
            SystemTime.wMinute := mm;
            SystemTime.wSecond := 0;
            SystemTime.wMilliseconds := 0;
            SetLocalTime(SystemTime);
            PostMessage(HWND_BROADCAST, WM_TIMECHANGE, 0, 0);
        end;
end;

end.

